//VERSION DE CONTROL REMOTO, SI RECIBE UNA "A"
//DESDE TINY EN MODO TERMINAL, RESPONDE CON EL MENSAJE:
//"ANTES DE 1 SEGUNDO,DE CLICK EN OPCION WRITE FLASH"
//Y ENTRA EN MODO BOOTLOADER (DURANTE 1 SEGUNDO), 
//PARA QUE EL USUARIO CARGUE UN NUEVO ARCHIVO.
//SI EN LA APLICACION DE RELOJ DIGITAL RECIBE UNA "B"
//PERMITE MODIFICAR LA HORA EN LINEA. SI RECIBE UNA "A"
//ENTRA EN MODO BOOTLOADER DURANTE 1 SEGUNDO.

#if defined(__PCM__)
#include "16f88adc.h"
#include <string.h>
#use delay (clock=4000000)
#use rs232 (baud=9600,xmit=PIN_B5,rcv=PIN_B2)
#rom 0X0000={0X018A,0X2803}         
#build(reset=0x0003)

unsigned int longitud;				//variable para guardar la longitud del mensaje
int BELO;
int af,cf,bf=0;						//bf es el elemento del arreglo pf[]
int i;							//variable ndice malla principal 
int k;							//variable ndice para arreglo pf[]
int bo;
int ze;
int jota,omega=0;				//variables indice para arreglo pf[]
//LINEA DE FORMATO*******1.................................................50................................................100...............................................150...............................................200............................................250
#ORG 0X500,0X5FE
const char mensaje[250]="......%&%&HOLA AMIGOS! ESTAN CORDIALMENTE INVITADOS AL PROXIMO EVENTO INAUGURAL DE NUESTRO AUDITORIO ESPECIAL PARA PRESENTACIONES DE PELICULAS EN TERCERA DIMENSION, CON CAPACIDAD PARA MAS DE 800 PERSONAS, GRACIAS!/(......";	//texto que habr de mostrarse.
#ORG 0X5FF
const int VELOCIDAD=6;  
char pf[60]; 					//arreglo con 60 patrones de columnas (10 caracteres)
#include "LETRASCCS4.h"

int8 return_val(void); 
int calcula(void);				//funcin calcula longitud de "mensaje[]"
void renglones(void);
void reset(void);
void pulso(void);
char timed_getc(); 
void main()
{ 
BELO=return_val();   				
CVRCON=0;
CMCON=7;
TRISA=0;    				
TRISB=4;
PORTA=0;
PORTB=0;
reset();
longitud=calcula();				//calcula longitud de mensaje[]
longitud=longitud-(longitud%4);
malla:
for(omega=0;omega<longitud;omega=omega+4)
{
jota=0;						
	for(k=0;k<10;k++)				//10 caracteres del arreglo "mensaje"
	{
	swatch(mensaje[k+omega]);		//acomoda patrn de columnas en arreglo pf[]
	if(mensaje[k+omega]=='%')goto sigue;  //si es caracter grfico,no aade rengn en blanco
	if(mensaje[k+omega]=='/')goto sigue2;
	pf[jota]=0;	
	jota=jota+1;					//deja una columna en blanco entre caracteres	
	continue;
	sigue:							//si es corazn, aade la columna que falta
	pf[jota]=0x3E;
	jota=jota+1;
	continue;
	sigue2:							//si es flecha, aade la columna que falta
	pf[jota]=0x38;
	jota=jota+1;	
	}			
   		for(bf=0;bf<24;bf++)		//activa el scrolling 24 veces
		{
			for(k=0;k<BELO;k++)			//RETRASO EN EL SCROLLING
   			{
   			i=0;        	  			//Inicializamos el contador auxiliar.
   			RA2=0;         				//dato=0	para ingresar un 0 a primera columna
   			pulso();       				//COLUMNA 0=0 este 0 se va a ir corriendo al resto de las columnas
   			RA2=1;         				//dato=1  ingresan 1 a registros a cada incremento.
   				for (i=0;i<=29;i++)     //Hacemos el barrido de columnas.
   				{                                       
      			bo=pf[i+bf];            	//Barremos la variable que contiene los datos para escribir en las matrices.
      			renglones();           //Manda el dato de 7 bits.
//      		delay_us(200);			//RETRASO=200 us.
				ze=timed_getc();
				if (ze=='A')
				{PORTB=0;RA4=0;delay_ms(300);
				printf("ANTES DE 1 SEGUNDO, DE CLICK EN OPCION WRITE FLASH\r\n");
				#ASM					//ENTRA EN MODO BOOTLOADER
				GOTO 0;
				#ENDASM
				}	
      			pulso();             //activa siguiente columna
				PORTB=0;				//evita que encienda brevemente siguiente columna
				RA4=0;  
   				}
			
   			}
		}
}
goto malla;         					
}

//ESTA FUNCION CALCULA LA LONGITUD DEL STRING "mensaje[]"
//la funcin toma el valor del resultado, que es la variable "af"
int calcula(void)
{
af=0;
	while(1)
	{cf=mensaje[af];
	if(cf==0)return(af);	//ES CARACTER=0?
	af++;
	}
}

//ASIGNA DATO EN RENGLON A BIT DE PUERTOS:
//R0=RB0,R1=RB1,R2=RB3,R3=RB4,R4=RB6,R5=RB7,R6=RA4
//RB2 Y RB5 SE RESERVAN PARA EL PUERTO SERIAL.
void renglones(void)
{
   PORTB=0;
   RA4=0;  
   if (bit_test(bo,1)==1)      //asigna valores a bits.
   {RB0=1;}   
   if (bit_test(bo,2)==1)
   {RB1=1;}
   if (bit_test(bo,3)==1)      
   {RB3=1;}
   if (bit_test(bo,4)==1)      
   {RB4=1;}
   if (bit_test(bo,5)==1)      
   {RB6=1;}
   if (bit_test(bo,6)==1)      
   {RB7=1;}
   if (bit_test(bo,7)==1)      
   {RA4=1;}   
}

void reset(void)
{
RA0=0;
delay_ms(100);
RA0=1;
}

void pulso(void)
{
RA1=0;
RA1=1;
}

char timed_getc() 
{
long timeout;
timeout=0;
	while(!kbhit()&&(++timeout<21))   // 1 milisegundos
		delay_us(1);
		if(kbhit())			//hay caracter en buffer?
		return(getc());
		else {   
			return(0);
			}
	}

//FUNCION PERMITE LEER DIRECTAMENTE LA CONSTANTE EN LA DIRECCION 600H
//LA FUNCION REGRESA CON ESE VALOR

int8 return_val(void) 
{ 
   int8 temp; 
   #asm 
   call 0x600 			//changed to suit the required address 
   movwf temp 
   #endasm 
   return(temp); 
} 
